VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Line"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim parent As frmMain

Dim startlinex As Integer
Dim startliney As Integer
Dim endlinex As Integer
Dim endliney As Integer

Dim undoch As Changes

Public linew As Integer

Private Sub Class_Initialize()
    linew = 1
End Sub

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Sub MouseDown(Button As Integer, X As Single, Y As Single)
Dim curtilex As Integer
Dim curtiley As Integer
curtilex = (Int(((parent.hScr.value + X)) / (TileW * parent.magnifier.Zoom)))
curtiley = (Int(((parent.vscr.value + Y)) / (TileH * parent.magnifier.Zoom)))
If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023) Then
    Exit Sub
End If


    Dim tmptile As Integer
    If Button = vbLeftButton Then
        tmptile = parent.tilesetleft
    Else
        tmptile = parent.tilesetright
    End If

    If tmptile = 217 Or tmptile = 219 Or tmptile = 220 Then
        Exit Sub
    End If

    parent.undoredo.ResetRedo
    Set undoch = New Changes

    startlinex = curtilex
    startliney = curtiley
    
    If SharedVar.curtool = T_line Then
        Call DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, True)
    ElseIf SharedVar.curtool = T_rectangle Then
        Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, True)
    ElseIf SharedVar.curtool = T_ellipse Then
        Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, True)
    End If
    parent.mapchanged = True

End Sub

Sub MouseMove(Button As Integer, X As Single, Y As Single)
Dim curtilex As Integer
Dim curtiley As Integer
curtilex = (Int(((parent.hScr.value + X)) / (TileW * parent.magnifier.Zoom)))
curtiley = (Int(((parent.vscr.value + Y)) / (TileH * parent.magnifier.Zoom)))
If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023) Then
    Exit Sub
End If
If Not SharedVar.MouseDown Then
    Exit Sub
End If

    Dim tmptile As Integer
    If Button = vbLeftButton Then
        tmptile = parent.tilesetleft
    Else
        tmptile = parent.tilesetright
    End If
    
    If tmptile = 217 Or tmptile = 219 Or tmptile = 220 Then
        Exit Sub
    End If

    If endlinex = curtilex And endliney = curtiley Then
        Exit Sub
    End If

    parent.updatePreview

    If SharedVar.curtool = T_line Then
        Call DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, True)
    ElseIf SharedVar.curtool = T_rectangle Then
        Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, True)
    ElseIf SharedVar.curtool = T_ellipse Then
        Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, True)
    End If
    
    endlinex = curtilex
    endliney = curtiley
End Sub

Sub MouseUp(Button As Integer, X As Single, Y As Single)
Dim curtilex As Integer
Dim curtiley As Integer
curtilex = (Int(((parent.hScr.value + X)) / (TileW * parent.magnifier.Zoom)))
curtiley = (Int(((parent.vscr.value + Y)) / (TileH * parent.magnifier.Zoom)))
If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023) Then
    Exit Sub
End If

    Dim tmptile As Integer
    If Button = vbLeftButton Then
        tmptile = parent.tilesetleft
    Else
        tmptile = parent.tilesetright
    End If
    
    If tmptile = 217 Or tmptile = 219 Or tmptile = 220 Then
        Exit Sub
    End If

    If SharedVar.curtool = T_line Then
        Call DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, False)
    ElseIf SharedVar.curtool = T_rectangle Then
        Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, False)
    ElseIf SharedVar.curtool = T_ellipse Then
        Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, False)
    End If
    
    If parent.magnifier.UsingPixels Then
        parent.UpdateLevel
    Else
        parent.updatePreview
    End If
    
    Call parent.undoredo.AddToUndo(undoch)
End Sub

Sub DrawLine(tilenr As Integer, startx As Integer, starty As Integer, endx As Integer, endy As Integer, undoch As Changes, Optional onpreview As Boolean = True, Optional refresh As Boolean = True)
    Dim width As Integer
    width = linew
    Dim i As Integer
    Dim j As Integer
    If parent.tline.linew <> 1 Then
        For j = -Int(parent.tline.linew / 2) + 1 To Int(parent.tline.linew / 2)
            For i = -Int(parent.tline.linew / 2) + 1 To Int(parent.tline.linew / 2)
                Call DrawBaseLine(tilenr, startx + i, starty + j, endx + i, endy + j, undoch, onpreview, refresh)
            Next
        Next
    Else
        Call DrawBaseLine(tilenr, startx, starty, endx, endy, undoch, onpreview, refresh)
    End If
    
End Sub
Sub DrawBaseLine(tilenr As Integer, startx As Integer, starty As Integer, endx As Integer, endy As Integer, undoch As Changes, Optional onpreview As Boolean = True, Optional refresh As Boolean = True)
    ' Bresenham's line algorithm for Microsoft Visual Basic 6.0
    ' Implementation by Robert Lee  July, 2002 Public Domain
    
    Dim InitialX As Integer
    Dim InitialY As Integer
    Dim FinalX As Integer
    Dim FinalY As Integer
        
    InitialX = startx
    InitialY = starty
    FinalX = endx
    FinalY = endy
    
    Dim Steep As Boolean
    Dim DeltaX As Integer, DeltaY As Integer, Delta As Integer
    Dim StepX As Integer, StepY As Integer
    Dim Coord As Integer
     
    Steep = False
    DeltaX = Abs(FinalX - InitialX)
    If (FinalX - InitialX) > 0 Then
        StepX = 1
    Else
        StepX = -1
    End If
    DeltaY = Abs(FinalY - InitialY)
    If (FinalY - InitialY) > 0 Then
        StepY = 1
    Else
        StepY = -1
    End If
    
    If DeltaY > DeltaX Then
        Steep = True
        Swap InitialX, InitialY
        Swap DeltaX, DeltaY
        Swap StepX, StepY
    End If
    
    
    Dim lbx As Integer
    Dim lby As Integer

    lbx = Int(parent.hScr.value / (TileW * parent.magnifier.Zoom))
    lby = Int(parent.vscr.value / (TileH * parent.magnifier.Zoom))

    Delta = (DeltaY * 2) - DeltaX
    For Coord = 0 To DeltaX - 1
        If Steep Then
            If Not onpreview Then
                If isTileSpecial(parent, InitialY, InitialX) Then
                    Call SearchAndDestroyObject(parent, InitialY, InitialX, undoch, False)
                End If
                Call parent.setTile(InitialY, InitialX, tilenr, undoch)
                Call parent.UpdateLevelTile(InitialY, InitialX, False)
            Else
                If Not parent.magnifier.UsingPixels Then
                    BitBlt parent.picpreview.hdc, (InitialY - lbx) * (TileW * parent.magnifier.Zoom), (InitialX - lby) * (TileH * parent.magnifier.Zoom), (TileW * parent.magnifier.Zoom), (TileH * parent.magnifier.Zoom), parent.piczoomtileset.hdc, ((tilenr - 1) Mod 19) * (TileW * parent.magnifier.Zoom), Int((tilenr - 1) / 19) * (TileH * parent.magnifier.Zoom), vbSrcCopy
                Else
                    Call SetPixel(parent.picpreview.hdc, (InitialY - lbx), (InitialX - lby), TilePixelColor(tilenr))
                End If

            End If

            'if not
'            Me.PSet (InitialY, InitialX)
        Else
            If Not onpreview Then
                If isTileSpecial(parent, InitialX, InitialY) Then
                    Call SearchAndDestroyObject(parent, InitialX, InitialY, undoch, False)
                End If

                Call parent.setTile(InitialX, InitialY, tilenr, undoch)
                Call parent.UpdateLevelTile(InitialX, InitialY, False)
            Else
                If Not parent.magnifier.UsingPixels Then
                    BitBlt parent.picpreview.hdc, (InitialX - lbx) * (TileW * parent.magnifier.Zoom), (InitialY - lby) * (TileH * parent.magnifier.Zoom), (TileW * parent.magnifier.Zoom), (TileH * parent.magnifier.Zoom), parent.piczoomtileset.hdc, ((tilenr - 1) Mod 19) * (TileW * parent.magnifier.Zoom), Int((tilenr - 1) / 19) * (TileH * parent.magnifier.Zoom), vbSrcCopy
                Else
                    Call SetPixel(parent.picpreview.hdc, (InitialX - lbx), (InitialY - lby), TilePixelColor(tilenr))
                End If
            End If

        
'            Me.PSet (InitialX, InitialY)
        End If
        While Delta >= 0
            InitialY = InitialY + StepY
            Delta = Delta - (DeltaX * 2)
        Wend
        InitialX = InitialX + StepX
        Delta = Delta + (DeltaY * 2)
    Next Coord
    
    If Not onpreview Then
        If isTileSpecial(parent, FinalX, FinalY) Then
            Call SearchAndDestroyObject(parent, FinalX, FinalY, undoch, False)
        End If

        Call parent.setTile(FinalX, FinalY, tilenr, undoch)
        Call parent.UpdateLevelTile(FinalX, FinalY, False)
    Else
        If Not parent.magnifier.UsingPixels Then
            BitBlt parent.picpreview.hdc, (FinalX - lbx) * (TileW * parent.magnifier.Zoom), (FinalY - lby) * (TileH * parent.magnifier.Zoom), (TileW * parent.magnifier.Zoom), (TileH * parent.magnifier.Zoom), parent.piczoomtileset.hdc, ((tilenr - 1) Mod 19) * (TileW * parent.magnifier.Zoom), Int((tilenr - 1) / 19) * (TileH * parent.magnifier.Zoom), vbSrcCopy
        Else
            Call SetPixel(parent.picpreview.hdc, (FinalX - lbx), (FinalY - lby), TilePixelColor(tilenr))
        End If
    End If
    'Me.PSet (FinalX, FinalY)

    If refresh Then
        If Not onpreview Then
            parent.updatePreview
        Else
            parent.picpreview.refresh
        End If
    End If
    
 End Sub

Private Sub Swap(X As Integer, Y As Integer)
    Dim tmp As Integer
    tmp = X
    X = Y
    Y = tmp

 End Sub

 Sub DrawTileRectangle(tilenr As Integer, startx As Integer, starty As Integer, endx As Integer, endy As Integer, undoch As Changes, Optional onpreview As Boolean = True)
    Call DrawLine(tilenr, startx, starty, endx, starty, undoch, onpreview, False)
    Call DrawLine(tilenr, endx, starty, endx, endy, undoch, onpreview, False)
    Call DrawLine(tilenr, endx, endy, startx, endy, undoch, onpreview, False)
    Call DrawLine(tilenr, startx, endy, startx, starty, undoch, onpreview, False)
    
    If Not onpreview Then
        parent.updatePreview
    Else
        parent.picpreview.refresh
    End If
    
 End Sub

 Sub DrawEllipse(tilenr As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal xx As Integer, ByVal yy As Integer, undoch As Changes, Optional onpreview As Boolean = True)
    Dim cx#, cy#, px#, py#, xp#, yp#
    Dim theta#, dtheta#, a#, b#
    
    cx = X + (xx - X) / 2#
    cy = Y + (yy - Y) / 2#
    a = (xx - X) / 2#
    b = (yy - Y) / 2#
    
    dtheta = 0.05
    
    For theta = 0# To 2 * 3.14 + dtheta Step dtheta
        xp = cx + a * Cos(theta)
        yp = cy + b * Sin(theta)
        If theta <> 0 Then
            Call DrawLine(tilenr, CInt(xp), CInt(yp), CInt(px), CInt(py), undoch, onpreview, False) ' picpreview.Line (xp, yp)-(px, py)
        End If
        
        px = xp: py = yp
    Next theta
    
    If Not onpreview Then
        parent.updatePreview
    Else
        parent.picpreview.refresh
    End If

End Sub

