Attribute VB_Name = "General"
Option Explicit

Declare Function GetTickCount Lib "kernel32" () As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Declare Function SetStretchBltMode Lib "gdi32" (ByVal hdc As Long, ByVal nStretchMode As Long) As Long

Declare Function GetFileSize Lib "kernel32" (ByVal hFile As Long, lpFileSizeHigh As Long) As Long
Global Const OF_READ = &H0&
Declare Function lOpen Lib "kernel32" Alias "_lopen" (ByVal lpPathName As String, ByVal iReadWrite As Long) As Long
Declare Function lclose Lib "kernel32" Alias "_lclose" (ByVal hFile As Long) As Long

Global Const COLORONCOLOR = 3
Global Const HALFTONE = 4


Global Const SWP_NOMOVE = 2
Global Const SWP_NOSIZE = 1
Global Const HWND_TOPMOST = -1
Global Const HWND_NOTOPMOST = -2
Global Const FLOAT = 1, SINK = 0

Public Declare Sub SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)

Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

Sub DrawRectangle(pic As PictureBox, Left As Integer, Right As Integer, Top As Integer, Bottom As Integer, color As Long, Optional adjust As Integer)
    Dim oldcolor As Long
    oldcolor = pic.ForeColor
    pic.ForeColor = color
    
    Dim adj As Integer
    If IsMissing(adjust) Then
        adj = 0
    Else
        adj = adjust
    End If
    
    pic.Line (Left - adj, Top - adj)-(Right + adj, Top - adj)
    pic.Line (Right + adj, Top - adj)-(Right + adj, Bottom + adj)
    pic.Line (Right + adj, Bottom + adj)-(Left - adj, Bottom + adj)
    pic.Line (Left - adj, Bottom + adj)-(Left - adj, Top - adj)
    
    pic.FillColor = oldcolor
    
End Sub

Function GetFileTitle(path As String)
Dim temp() As String
Dim output As String

If path = "" Then
GetFileTitle = ""
Exit Function
End If

temp = Split(path, "\")

output = temp(UBound(temp))
If output = "" Then
output = temp(UBound(temp) - 1)
End If

GetFileTitle = output
End Function


Function GetExtention(filetitle As String)
Dim temp() As String
Dim output As String
temp = Split(filetitle, ".")
output = temp(UBound(temp))

GetExtention = output
End Function



























''/* Arguments:
'' *        Pointer to bitmap to fill, (x,y) coordinates of seed point,
'' *        color used for solid or masked fills, border color used if area to
'' *        be filled is outlined (or CLR_INVALID).
'' *
'' * Returns:
'' *         0 = Success.
'' *        -1 = Invalid seed point.
'' *        -2 = Memory allocation error.
'' *        -3 = Invalid bitmap or unknown error.
'' */
'
'Dim m_CurStackSize As Long
'Dim m_MaxStackSize As Long
'Dim m_VisitSize As Long
'Dim m_CurrentLine As Long
'
'Dim m_bXSortOn As Boolean
'Dim m_bMemError As Boolean
'Dim m_LastY As Integer
'
'Function QuickFill(pic As PictureBox, x As Integer, y As Integer, fill_color As Long, border_color As Long) As Long
'
'    Dim ThisColor  As Long
'    Dim MaxY As Integer
'    Dim MaxX As Integer
'    Dim Dy As Integer
'    Dim ChildLeft As Integer
'    Dim ChildRight As Integer
'    Dim ParentLeft As Integer
'    Dim ParentRight As Integer
'
'    m_CurStackSize = 0
'    m_MaxStackSize = 0
'    m_VisitSize = 0
'
'    m_CurrentLine = 0
'    m_bXSortOn = False
'    m_bMemError = False
'    m_LastY = -1
'
'    '/* Initialize internal info based on fill type */
'    If clr_invalid <> border_color Then
'        '/* Check color at x,y position */
'        ThisColor = GetPixel(pic.hdc, x, y)
'
'        If ThisColor = border_color Then
'            QuickFill = -1
'            Exit Function
'        End If
'
'        ThisColor = BorderColor
'        m_bXSortOn = True
'    Else
'        '/* Check color at x,y position */
'        ThisColor = GetPixel(pic.hdc, x, y)
'
'        ' //////// what is m_DibPattern.GetDibPtr() ???
'
'        If ThisColor = fill_color Then  'and not m_DibPattern.GetDibPtr()
'            QuickFill = -1
'            Exit Function
'        End If
'
'        ' ///////// what's this ?????
'
'        'if( m_DibPattern.GetDibPtr() || memcmp(m_FillMask,_SolidMask,8) )
'        '    m_bXSortOn = TRUE;
'    End If
'
'    '/////////// how can i do this in vb ????
'
'    '/* Using macros because we can not uses pointer to member functions.
'    ' * This makes the code less efficient, but solves the problem.
'    ' */
''#define FindLeft(x,y,xmin,color) \
''    ((CLR_INVALID != border_color) \
''    ? SearchLeft(x,y,xmin,color) : ScanLeft(x,y,xmin,color))
''#define FindRight(x,y,xmax,color) \
''    ((CLR_INVALID != border_color) \
''    ? SearchRight(x,y,xmax,color) : ScanRight(x,y,xmax,color))
''#define SkipRight(x,y,xmax,color) \
''    ((CLR_INVALID != border_color) \
''    ? ScanRight(x,y,xmax,color) : SearchRight(x,y,xmax,color))
'
'
'    ' //////////// eh ?
'
'    '/* Initialize Line list */
'    'if( MakeList() )
'    '    return -2;
'
'    '/* Initialize maximum coords */
'    MaxX = pic.ScaleWidth - 1
'    MaxY = pic.ScaleHeight - 1
'
'    '/* Push starting point on stack */
'    Call PushLine(x, x, y, 1) '/* Needed in one special case */
'    Call PushLine(x, x, y + 1, -1)
'
'    '/* Now start flooding */
'    Do While m_plinelist
'        Call PopLine(ParentLeft, ParentRight, y, Dy)
'        y = y + Dy
'        If y < 0 Or MaxY < y Then
'            ' what is continue ? exit do ?
'            'continue;
'        End If
'        If m_bMemError Then
'            'continue;
'        End If
'        If m_bXSortOn And isrevisit(ParentLeft, ParentRight, y) Then
'            'continue;
'        End If
'    Loop
'
'    '/* Find ChildLeft end ( ChildLeft>ParentLeft on failure ) */
'    ChildLeft = FindLeft(ParentLeft, y, 0, ThisColor) + 1
'    If ChildLeft <= ParentLeft Then
'        '/* Find ChildRight end ( this should not fail here ) */
'        ChildRight = FindRight(ParentLeft, y, MaxX, ThisColor) - 1
'
'        If ChildLeft = ChildRight Then
'            Call SetPixel(pic.hdc, x, y, fill_color)
'        Else
'            Line (ChildLeft, ChildRight)-(y, fill_color)
'        End If
'
'        '/* Push unvisited lines */
'        If ParentLeft - 1 <= ChildLeft And ChildRight <= ParentRight + 1 Then
'            Call PushLine(ChildLeft, ChildRight, y, Dy)
'        Else
'            If m_bXSortOn Then
'                Call PushOpposite(ParentLeft, ParentRight, ChildLeft, ChildRight, y, Dy)
'            Else
'                Call PushLine(ChildLeft, ChildRight, y, -Dy)
'            End If
'            Call PushLine(ChildLeft, ChildRight, y, Dy)
'        End If
'
'        '/* Addvance ChildRight end on to border */
'        ChildRight = ChildRight + 1
'    Else
'        ChildRight = ParentLeft
'    End If
'
'    '/* Fill betweens */
'
'    Do While ChildRight < ParentRight
'        '/* Skip to new ChildLeft end, ( ChildRight>ParentRight on failure ) */
'        ChildRight = SkipRight(ChildRight, y, ParentRight, ThisColor)
'        If ChildRight <= ParentRight Then
'            ChildLeft = ChildRight
'            '/* Find ChildRight end ( this should not fail here ) */
'            ChildRight = FindRight(ChildLeft, y, MaxX, ThisColor) - 1
'            '/* Fill line */
'            If ChildLeft = ChildRight Then
'                Call SetPixel(pic.hdc, ChildRight, y, fill_color)
'            Else
'                Line (ChildLeft, ChildRight)-(y, fill_color)
'            End If
'
'            '/* Push unvisited lines */
'            If ChildRight <= ParentRight + 1 Then
'                Call PushLine(ChildLeft, ChildRight, y, Dy)
'            Else
'                If m_bXSortOn Then
'                    Call PushOpposite(ParentLeft, ParentRight, ChildLeft, ChildRight, y, Dy)
'                Else
'                    Call PushLine(ChildLeft, ChildRight, y, -Dy)
'                End If
'                Call PushLine(ChildLeft, ChildRight, y, Dy)
'            End If
'
'            '/* Addvance ChildRight end onto border */
'            ChildRight = ChildRight + 1
'        End If
'    Loop
'
'    '/* Push visited line onto visited stack */
'    If m_bXSortOn Then
'        Call PushVisitedLine(ParentLeft, ParentRight, y)
'    End If
'
'    '??
'    Call FreeList
'    'm_DibData.SetDIBits(pBitmap);
'    'm_DibData.DeleteObject();
'
'    QuickFill = IIf(m_bMemError, -2, 0)
'
'End Function
