VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SPLine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim parent As frmMain

Dim startlinex As Integer
Dim startliney As Integer
Dim endlinex As Integer
Dim endliney As Integer

Dim allowlinedraw As Boolean
Dim curtile As Integer

Dim undoch As Changes

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Sub MouseDown(Button As Integer, X As Single, Y As Single)
Dim curtilex As Integer
Dim curtiley As Integer
curtilex = (Int(((parent.hScr.value + X)) / (TileW * parent.magnifier.Zoom)))
curtiley = (Int(((parent.vscr.value + Y)) / (TileH * parent.magnifier.Zoom)))
If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023) Then
    Exit Sub
End If
        
    Dim tmptile As Integer
    If Button = vbLeftButton Then
        tmptile = parent.tilesetleft
    Else
        tmptile = parent.tilesetright
    End If

    If tmptile = 217 Or tmptile = 219 Or tmptile = 220 Then
        Exit Sub
    End If


    If Button = vbLeftButton Then
        If allowlinedraw = False Then
            'begin of tool
                parent.undoredo.ResetRedo
                Set undoch = New Changes
                curtile = tmptile
        Else
            Call parent.tline.DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, False)
        End If
        allowlinedraw = True
    Else
        allowlinedraw = False
    End If
    
    startlinex = curtilex
    startliney = curtiley
    
    Call parent.tline.DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, True)
    
    If allowlinedraw = False Then
        'end of tool
        Call parent.undoredo.AddToUndo(undoch)
    End If
    
    If parent.magnifier.UsingPixels Then
        parent.UpdateLevel
    Else
        parent.updatePreview
    End If
    parent.mapchanged = True

End Sub

Sub MouseMove(Button As Integer, X As Single, Y As Single)
Dim curtilex As Integer
Dim curtiley As Integer
curtilex = (Int(((parent.hScr.value + X)) / (TileW * parent.magnifier.Zoom)))
curtiley = (Int(((parent.vscr.value + Y)) / (TileH * parent.magnifier.Zoom)))
If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023) Then
    Exit Sub
End If

If Not allowlinedraw Then
    Exit Sub
End If

    If curtile = 217 Or curtile = 219 Or curtile = 220 Then
        Exit Sub
    End If

    If endlinex = curtilex And endliney = curtiley Then
        Exit Sub
    End If

    parent.updatePreview

    Call parent.tline.DrawLine(curtile, startlinex, startliney, curtilex, curtiley, undoch, True)
    
    endlinex = curtilex
    endliney = curtiley
End Sub

Sub MouseUp(Button As Integer, X As Single, Y As Single)
End Sub
